
/* 
 *          Gnome Rhythm, by stoney -- lstone@gate.net
 *
 *  This is grhythm.h  - part of the gRhythm program.
 *  gRhythm is free software. Details of the copyright are in the
 *  file called COPYING.
 *
 *
 */ 
 
 #define VERSION "0.1"
 #define MAXPOINTS 8000   /* 65536 (2^16) is maximum X-server will draw */
 #define OFF  0
 #define ON   1
 #define BASICS   1
 #define TUTORIAL 2
 #define PRACTICE 3

 /* including won't work for some reason */
 
 struct GdkPoint {
    gint16 x;
    gint16 y;
  };
 
 /* MOST program variables are here */
 
 struct grhythm_data {
    gint total_segments;
    gint ds;        
    GdkGC *gc; 
    GdkFont *font;
    gint section;
    gint elements; 
    gint segment;  
    gint strip_running;
    gint show_grid;
    gint eos;
    gint current;
    gfloat num_attempted;
    gfloat num_correct;
    gfloat score;   
   } grdata; 
    
 /* prototypes */
 
 static void not_imp_cb(GtkWidget *widget, gpointer data);
 static void error_dialog_cb(char *message);
 static void about_cb (GtkWidget *widget, gpointer data);
 void get_main_menu(GtkWidget *window, GtkWidget **menubar );
 void delete_event(GtkWidget *widget, GdkEvent *event, gpointer data); 
 void gtk_quit();
 static gint configure_event(GtkWidget *widget, GdkEventConfigure *event );
 static gint expose_event(GtkWidget *widget,GdkEventExpose *event );
 static gboolean grhythm_draw_strip(GtkWidget *widget); 
 static gint grhythm_get_segment(GtkWidget *widget);
 static void grhythm_draw_legend(GtkWidget *widget);
 static void button_press_event (GtkWidget *widget, gpointer data);
 static gint grhythm_fill_strip(gint drawing_size, gint elements);
 static gboolean grhythm_animate_strip(GtkWidget *widget);
 static void grhythm_do_basics(GtkWidget *widget);
 static void grhythm_do_tutorial(GtkWidget *widget);
 static void grhythm_do_practice(GtkWidget *widget); 
 static gint grhythm_wrap_text(GtkWidget *widget, gchar *string, gint x_start, 
                                gint y_start,gint linewidth,gint indent,gint lineheight);
 static void grhythm_delay(gulong msec);
 static void grhythm_jump_reverse(GtkWidget *widget, GtkWidget *drawspace);
 static void grhythm_dec_strip(GtkWidget *widget, GtkWidget *drawspace);
 static void grhythm_inc_strip(GtkWidget *widget, GtkWidget *drawspace);
 static void grhythm_jump_forward(GtkWidget *widget, GtkWidget *drawspace);
 static void grhythm_grid_toggle(GtkWidget *widget);
 static void grhythm_static_toggle(GtkWidget *widget);
